

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.Plot &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="Python programs and modules" href="index.html" />
    <link rel="next" title="pywws.WindRose" href="pywws.WindRose.html" />
    <link rel="prev" title="pywws.calib" href="pywws.calib.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.WindRose.html" title="pywws.WindRose"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="pywws.calib.html" title="pywws.calib"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="pywws-plot">
<h1>pywws.Plot<a class="headerlink" href="#pywws-plot" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>Like Template.py this is one of the more difficult to use modules in the weather station software collection. It plots a graph (or set of graphs) of weather data. Almost everything about the graph is controlled by an XML file. I refer to these files as templates, but they aren&#8217;t templates in the same sense as Template.py uses to create text files.</p>
<p>Before writing your own graph template files, it might be useful to look at some of the examples in the example_graph_templates directory. If (like I was) you are unfamiliar with XML, I suggest reading the W3 Schools XML tutorial.</p>
<div class="section" id="xml-graph-file-syntax">
<h3>XML graph file syntax<a class="headerlink" href="#xml-graph-file-syntax" title="Permalink to this headline">¶</a></h3>
<p>Here is the simplest useful graph template. It plots the external temperature for the last 24 hours.</p>
<div class="highlight-python"><pre>&lt;?xml version="1.0" encoding="ISO-8859-1"?&gt;
&lt;graph&gt;
  &lt;plot&gt;
    &lt;subplot&gt;
      &lt;title&gt;Temperature (°C)&lt;/title&gt;
      &lt;ycalc&gt;data['temp_out']&lt;/ycalc&gt;
    &lt;/subplot&gt;
  &lt;/plot&gt;
&lt;/graph&gt;</pre>
</div>
<p>In this example, the root element graph has one plot element, which has one subplot element. The subplot element contains a title element and a ycalc element. To plot more data on the same set of axes (for example dew point and temperature), we can add more subplot elements. To plot more than one set of axes (for example wind speed is measured in different units from temperature) in the same file we can add more plot elements.</p>
<p>The complete element hierarchy is shown below.</p>
<div class="highlight-python"><pre>graph
    plot
        subplot
            xcalc
            ycalc
            axes
            style
            colour
            title
        bmargin
        yrange
        y2range
        ytics
        y2tics
        ylabel
        ylabelangle
        y2label
        y2labelangle
        grid
        source
        boxwidth
        title
        command
    start
    stop
    duration
    layout
    size
    fileformat
    terminal
    lmargin
    rmargin
    xformat
    xlabel
    dateformat
    xtics
    title</pre>
</div>
</div>
<div class="section" id="graph">
<h3>graph<a class="headerlink" href="#graph" title="Permalink to this headline">¶</a></h3>
<p>This is the root element of the graph XML file. It does not have to be called &#8220;graph&#8221;, but there must be exactly one root element.</p>
</div>
<div class="section" id="plot">
<h3>plot<a class="headerlink" href="#plot" title="Permalink to this headline">¶</a></h3>
<p>Every graph element should contain at least one plot element. A separate graph is drawn for each plot element, but all share the same X axis.</p>
</div>
<div class="section" id="start">
<h3>start<a class="headerlink" href="#start" title="Permalink to this headline">¶</a></h3>
<p>This element sets the date &amp; time of the start of the X axis. It is used in the constructor of a Python datetime object. For example, to start the graph at noon (local time) on Christmas day 2008: <tt class="docutils literal"><span class="pre">&lt;start&gt;year=2008,</span> <span class="pre">month=12,</span> <span class="pre">day=25,</span> <span class="pre">hour=12&lt;/start&gt;</span></tt>. The default value is (stop - duration).</p>
</div>
<div class="section" id="stop">
<h3>stop<a class="headerlink" href="#stop" title="Permalink to this headline">¶</a></h3>
<p>This element sets the date &amp; time of the end of the X axis. It is used in the constructor of a Python datetime object. For example, to end the graph at 10 am (local time) on new year&#8217;s day: <tt class="docutils literal"><span class="pre">&lt;stop&gt;year=2009,</span> <span class="pre">month=1,</span> <span class="pre">day=1,</span> <span class="pre">hour=10&lt;/stop&gt;</span></tt>. The default value is (start + duration), unless start is not defined in which case the timestamp of the latest weather station hourly reading is used.</p>
</div>
<div class="section" id="duration">
<h3>duration<a class="headerlink" href="#duration" title="Permalink to this headline">¶</a></h3>
<p>This element sets the extent of the X axis of the graph, unless both start and stop are defined. It is used in the constructor of a Python timedelta object. For example, to plot one week: <tt class="docutils literal"><span class="pre">&lt;duration&gt;weeks=1&lt;/duration&gt;</span></tt>. The default value is hours=24.</p>
</div>
<div class="section" id="layout">
<h3>layout<a class="headerlink" href="#layout" title="Permalink to this headline">¶</a></h3>
<p>Controls the layout of the plots. Default is a single column. The layout element specifies rows and columns. For example: <tt class="docutils literal"><span class="pre">&lt;layout&gt;4,</span> <span class="pre">2&lt;/layout&gt;</span></tt> will use a grid of 4 rows and 2 columns.</p>
</div>
<div class="section" id="size">
<h3>size<a class="headerlink" href="#size" title="Permalink to this headline">¶</a></h3>
<p>Sets the overall dimensions of the image file containing the graph. Default (in a single column layout) is a width of 600 pixels and height of 200 pixels for each plot, so a graph with four plot elements would be 600 x 800 pixels. Any size element must include both width and height. For example: <tt class="docutils literal"><span class="pre">&lt;size&gt;800,</span> <span class="pre">600&lt;/size&gt;</span></tt> will produce an image 800 pixels wide and 600 pixels high.</p>
</div>
<div class="section" id="fileformat">
<h3>fileformat<a class="headerlink" href="#fileformat" title="Permalink to this headline">¶</a></h3>
<p>Sets the image format of the file containing the graph. Default is png. Any string recognised by your installation of gnuplot should do. For example: <tt class="docutils literal"><span class="pre">&lt;fileformat&gt;gif&lt;/fileformat&gt;</span></tt> will produce a GIF image.</p>
</div>
<div class="section" id="terminal">
<h3>terminal<a class="headerlink" href="#terminal" title="Permalink to this headline">¶</a></h3>
<p>Allows complete control of gnuplot&#8217;s &#8216;terminal&#8217; settings. You may want to use this if you are plotting to an unusual image format. Any string recognised by your installation of gnuplot&#8217;s &#8216;set terminal&#8217; command should do. For example: <tt class="docutils literal"><span class="pre">&lt;terminal&gt;svg</span> <span class="pre">enhanced</span> <span class="pre">font</span> <span class="pre">&quot;arial,9&quot;</span> <span class="pre">size</span> <span class="pre">600,800</span> <span class="pre">dynamic</span> <span class="pre">rounded&lt;/terminal&gt;</span></tt>. This setting overwrites both size and fileformat.</p>
</div>
<div class="section" id="lmargin">
<h3>lmargin<a class="headerlink" href="#lmargin" title="Permalink to this headline">¶</a></h3>
<p>Sets the left margin of the plots, i.e. the distance from the left hand axis to the left hand edge of the image area. According to the gnuplot documentation the units of lmargin are character widths. The default value is 5, which should look OK in most circumstances.</p>
</div>
<div class="section" id="rmargin">
<h3>rmargin<a class="headerlink" href="#rmargin" title="Permalink to this headline">¶</a></h3>
<p>Sets the right margin of the plots, i.e. the distance from the right hand axis to the right hand edge of the image area. According to the gnuplot documentation the units of rmargin are character widths. The default value is -1, which sets automatic adjustment.</p>
</div>
<div class="section" id="xformat">
<h3>xformat<a class="headerlink" href="#xformat" title="Permalink to this headline">¶</a></h3>
<p>Sets the format of the time / date xtic labels. The value is a strftime style format string. Default depends on the graph duration: 24 hours or less is &#8220;%H%M&#8221;, 24 hours to 7 days is &#8220;%a %d&#8221; and 7 days or more is &#8220;%Y/%m/%d&#8221;.</p>
</div>
<div class="section" id="xlabel">
<h3>xlabel<a class="headerlink" href="#xlabel" title="Permalink to this headline">¶</a></h3>
<p>Sets the X axis label. The value is a strftime style format string. Default depends on the graph duration: 24 hours or less is &#8220;Time (%Z)&#8221;, 24 hours to 7 days is &#8220;Day&#8221; and 7 days or more is &#8220;Date&#8221;. The datetime used to compute this is start, which may produce unexpected results when a graph spans DST start or end.</p>
</div>
<div class="section" id="dateformat">
<h3>dateformat<a class="headerlink" href="#dateformat" title="Permalink to this headline">¶</a></h3>
<p>Sets the format of the date labels at each end of X axis. The value is a strftime style format string. Default is &#8220;%Y/%m/%d&#8221;. The right hand label is only drawn if it differs from the left. To have no labels, set an empty format: <tt class="docutils literal"><span class="pre">&lt;dateformat&gt;&lt;/dateformat&gt;</span></tt></p>
</div>
<div class="section" id="xtics">
<h3>xtics<a class="headerlink" href="#xtics" title="Permalink to this headline">¶</a></h3>
<p>Sets the spacing of the &#8220;tic&#8221; marks on the X axis. The value is an integer number of hours. The default is to allow gnuplot to set an appropriate interval.</p>
</div>
<div class="section" id="title">
<h3>title<a class="headerlink" href="#title" title="Permalink to this headline">¶</a></h3>
<p>Sets the title of the graph. A single line of text, for example: <tt class="docutils literal"><span class="pre">&lt;title&gt;Today's</span> <span class="pre">weather&lt;/title&gt;</span></tt>. This title appears at the very top of the graph, outside any plot area.</p>
</div>
<div class="section" id="subplot">
<h3>subplot<a class="headerlink" href="#subplot" title="Permalink to this headline">¶</a></h3>
<p>Every plot element should contain at least one subplot element. A separate trace is drawn for each subplot element, but all share the same X and Y axes.</p>
</div>
<div class="section" id="bmargin">
<h3>bmargin<a class="headerlink" href="#bmargin" title="Permalink to this headline">¶</a></h3>
<p>Sets the bottom margin, i.e. the spacing between the lower X axis and the edge of the graph (or the next plot). The default is to let gnuplot adjust this automatically, which works OK most of the time but you may wish to fine tune the value to suit your installation.</p>
<p>The permitted value is any non-negative real number. On my setup 0.9 is a good value, set as follows: <tt class="docutils literal"><span class="pre">&lt;bmargin&gt;0.9&lt;/bmargin&gt;</span></tt>.</p>
</div>
<div class="section" id="yrange">
<h3>yrange<a class="headerlink" href="#yrange" title="Permalink to this headline">¶</a></h3>
<p>Sets the lower and upper limits of the (left hand) Y axis. The value is anything understood by gnuplot, typically a pair of numbers. The default is to allow gnuplot to set appropriate values, which is unlikely to be what you want. For example, to plot typical UK temperatures with no value going off the graph: <tt class="docutils literal"><span class="pre">&lt;yrange&gt;-10,</span> <span class="pre">30&lt;/yrange&gt;</span></tt>. Note that commas are converted to colons, so <tt class="docutils literal"><span class="pre">&lt;yrange&gt;-10:30&lt;/yrange&gt;</span></tt> would be equivalent.</p>
<p>You can use an asterisk to have gnuplot choose a suitable value. For example, to have the upper value auto scale whilst fixing the lower value at zero, use <tt class="docutils literal"><span class="pre">&lt;yrange&gt;0:*&lt;/yrange&gt;</span></tt>.</p>
</div>
<div class="section" id="y2range">
<h3>y2range<a class="headerlink" href="#y2range" title="Permalink to this headline">¶</a></h3>
<p>Sets the lower and upper limits of the right hand Y axis. Default is for the right hand Y axis to be the same as the left, but setting a different range is useful in dual axis plotting.</p>
</div>
<div class="section" id="ytics">
<h3>ytics<a class="headerlink" href="#ytics" title="Permalink to this headline">¶</a></h3>
<p>Controls the &#8220;tic&#8221; marks on the left hand Y axis. The value can be anything that&#8217;s understood by gnuplot. For example, to set the tic spacing to 45 use <tt class="docutils literal"><span class="pre">&lt;ytics&gt;45&lt;/ytics&gt;</span></tt>. More complex things are also possible, e.g. to label a wind direction graph with compass points, use <tt class="docutils literal"><span class="pre">&lt;y2tics&gt;('N'</span> <span class="pre">0,</span> <span class="pre">'E'</span> <span class="pre">90,</span> <span class="pre">'S'</span> <span class="pre">180,</span> <span class="pre">'W'</span> <span class="pre">270,</span> <span class="pre">'N'</span> <span class="pre">360)&lt;/y2tics&gt;</span></tt>.</p>
</div>
<div class="section" id="y2tics">
<h3>y2tics<a class="headerlink" href="#y2tics" title="Permalink to this headline">¶</a></h3>
<p>Controls the &#8220;tic&#8221; marks on the right hand axis. The format is the same as that for ytics. Default behaviour is to copy the left hand tic marks, but without labels.</p>
</div>
<div class="section" id="ylabel">
<h3>ylabel<a class="headerlink" href="#ylabel" title="Permalink to this headline">¶</a></h3>
<p>Adds a label to the (left hand) Y axis. For example, when plotting temperature: <tt class="docutils literal"><span class="pre">&lt;ylabel&gt;°C&lt;/ylabel&gt;</span></tt>. If you use ylabel you will probably want to adjust lmargin.</p>
</div>
<div class="section" id="ylabelangle">
<h3>ylabelangle<a class="headerlink" href="#ylabelangle" title="Permalink to this headline">¶</a></h3>
<p>Adjust the angle of the (left hand) Y axis label, if your version of gnuplot supports it. For example, to write the label horizontally: <tt class="docutils literal"><span class="pre">&lt;ylabelangle&gt;90&lt;/ylabelangle&gt;</span></tt>.</p>
</div>
<div class="section" id="y2label">
<h3>y2label<a class="headerlink" href="#y2label" title="Permalink to this headline">¶</a></h3>
<p>Adds a label to the right hand Y axis. For example, when plotting humidity: <tt class="docutils literal"><span class="pre">&lt;y2label&gt;%&lt;/y2label&gt;</span></tt>. This is mostly used when plotting dual axis graphs. If you use y2label you will probably want to adjust rmargin.</p>
</div>
<div class="section" id="y2labelangle">
<h3>y2labelangle<a class="headerlink" href="#y2labelangle" title="Permalink to this headline">¶</a></h3>
<p>Adjust the angle of the right hand Y axis label, if your version of gnuplot supports it. For example, to write the label horizontally: <tt class="docutils literal"><span class="pre">&lt;y2labelangle&gt;90&lt;/y2labelangle&gt;</span></tt>.</p>
</div>
<div class="section" id="grid">
<h3>grid<a class="headerlink" href="#grid" title="Permalink to this headline">¶</a></h3>
<p>Adds a grid to the plot. In most situations gnuplot&#8217;s default grid is suitable, so no value is needed: <tt class="docutils literal"><span class="pre">&lt;grid&gt;&lt;/grid&gt;</span></tt>. More control is possible using any of the options understood by gnuplot&#8217;s set grid command. For example, to have horizontal grid lines only: <tt class="docutils literal"><span class="pre">&lt;grid&gt;ytics&lt;/grid&gt;</span></tt>.</p>
</div>
<div class="section" id="source">
<h3>source<a class="headerlink" href="#source" title="Permalink to this headline">¶</a></h3>
<p>Select the weather data to be plotted. Permitted values are <tt class="docutils literal"><span class="pre">&lt;source&gt;raw&lt;/source&gt;</span></tt>, <tt class="docutils literal"><span class="pre">&lt;source&gt;hourly&lt;/source&gt;</span></tt>, <tt class="docutils literal"><span class="pre">&lt;source&gt;daily&lt;/source&gt;</span></tt> and <tt class="docutils literal"><span class="pre">&lt;source&gt;monthly&lt;/source&gt;</span></tt>. Default is raw. Note that the different sources have different data dictionaries, so this choice affects ycalc.</p>
</div>
<div class="section" id="boxwidth">
<h3>boxwidth<a class="headerlink" href="#boxwidth" title="Permalink to this headline">¶</a></h3>
<p>Sets the width of the &#8220;boxes&#8221; used when drawing bar graphs. The value is an integer expression yielding a number of seconds. Default depends on source: raw is 240, hourly is 2800 and daily is 2800 * 24.</p>
</div>
<div class="section" id="id1">
<h3>title<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h3>
<p>Sets the title of the plot. A single line of text, for example: <tt class="docutils literal"><span class="pre">&lt;title&gt;Temperature</span> <span class="pre">(°C)&lt;/title&gt;</span></tt>. This title appears within the plot area, above any subplot titles.</p>
</div>
<div class="section" id="command">
<h3>command<a class="headerlink" href="#command" title="Permalink to this headline">¶</a></h3>
<p>Execute any gnuplot command, just before the main &#8220;plot&#8221; command. This option allows advanced users to have greater control over the graph appearance. The value is any valid gnuplot command, typically beginning with the word set. For example: <tt class="docutils literal"><span class="pre">&lt;command&gt;set</span> <span class="pre">key</span> <span class="pre">tmargin</span> <span class="pre">center</span> <span class="pre">horizontal</span> <span class="pre">width</span> <span class="pre">1</span> <span class="pre">noreverse</span> <span class="pre">enhanced</span> <span class="pre">autotitles</span> <span class="pre">box</span> <span class="pre">linetype</span> <span class="pre">-1</span> <span class="pre">linewidth</span> <span class="pre">1&lt;/command&gt;</span></tt>. (Don&#8217;t ask me what this example does — I&#8217;m not an advanced user).</p>
</div>
<div class="section" id="xcalc">
<h3>xcalc<a class="headerlink" href="#xcalc" title="Permalink to this headline">¶</a></h3>
<p>Controls the X axis positioning of plotted data values. The default value of data[&#8216;idx&#8217;] is correct for most data, but there are some exceptions. For example, when plotting bar charts of hourly rainfall, it&#8217;s nice to centre the bars on 30 minutes past the hour: <tt class="docutils literal"><span class="pre">&lt;xcalc&gt;data['idx'].replace(minute=30,</span> <span class="pre">second=0)&lt;/xcalc&gt;</span></tt>.</p>
</div>
<div class="section" id="ycalc">
<h3>ycalc<a class="headerlink" href="#ycalc" title="Permalink to this headline">¶</a></h3>
<p>Selects the data to be plotted. Any one line Python expression that returns a single float value can be used. At its simplest this just selects one value from the &#8220;data&#8221; dictionary, for example: <tt class="docutils literal"><span class="pre">&lt;ycalc&gt;data['temp_out']&lt;/ycalc&gt;</span></tt> plots the external temperature. More complex expressions are possible, and some helper functions are provided. For example: <tt class="docutils literal"><span class="pre">&lt;ycalc&gt;dew_point(data['temp_out'],</span> <span class="pre">data['hum_out'])&lt;/ycalc&gt;</span></tt> plots the external dew point, and <tt class="docutils literal"><span class="pre">&lt;ycalc&gt;data['wind_ave']</span> <span class="pre">*</span> <span class="pre">3.6</span> <span class="pre">/</span> <span class="pre">1.609344&lt;/ycalc&gt;</span></tt> plots the average wind speed in miles per hour.</p>
<p>Cumulative plots are also possible. The result of each ycalc computation is stored and made available to the next computation in the variable last_ycalc. This can be used with any data, but is most useful with rainfall: <tt class="docutils literal"><span class="pre">&lt;ycalc&gt;data['rain']</span> <span class="pre">+</span> <span class="pre">last_ycalc&lt;/ycalc&gt;</span></tt>.</p>
</div>
<div class="section" id="axes">
<h3>axes<a class="headerlink" href="#axes" title="Permalink to this headline">¶</a></h3>
<p>Selects which Y axis the data is plotted against. Default is the left hand axis, but the right hand axis can be chosen with: <tt class="docutils literal"><span class="pre">&lt;axes&gt;x1y2&lt;/axes&gt;</span></tt>. This can be used in conjunction with y2range to plot two unrelated quantities on one graph, for example temperature and humidity.</p>
</div>
<div class="section" id="style">
<h3>style<a class="headerlink" href="#style" title="Permalink to this headline">¶</a></h3>
<p>Sets the line style for the graph. Default is a smooth continuous line, thickness 1. To select a bar graph use: <tt class="docutils literal"><span class="pre">&lt;style&gt;box&lt;/style&gt;</span></tt>. To select points without a connecting line use: <tt class="docutils literal"><span class="pre">&lt;style&gt;+&lt;/style&gt;</span></tt> or <tt class="docutils literal"><span class="pre">&lt;style&gt;x&lt;/style&gt;</span></tt>. To select a line thickness 3 (for example) use: <tt class="docutils literal"><span class="pre">&lt;style&gt;line</span> <span class="pre">3&lt;/style&gt;</span></tt>. The thickness of points can be set in a similar fashion. For complete control (for advanced users) a full gnuplot style can be set: <tt class="docutils literal"><span class="pre">&lt;style&gt;smooth</span> <span class="pre">unique</span> <span class="pre">lc</span> <span class="pre">5</span> <span class="pre">lw</span> <span class="pre">3&lt;/style&gt;</span></tt>.</p>
</div>
<div class="section" id="colour">
<h3>colour<a class="headerlink" href="#colour" title="Permalink to this headline">¶</a></h3>
<p>Sets the colour of the subplot line or boxes. Any integer value is accepted. The mapping of colours to numbers is set by gnuplot. Default value is the previous colour plus one.</p>
</div>
<div class="section" id="id2">
<h3>title<a class="headerlink" href="#id2" title="Permalink to this headline">¶</a></h3>
<p>Sets the title of the subplot. A single line of text, for example: <tt class="docutils literal"><span class="pre">&lt;title&gt;Temperature</span> <span class="pre">(°C)&lt;/title&gt;</span></tt>. This title appears within the plot area, next to a short segment of the line colour used for the subplot.</p>
</div>
</div>
<div class="section" id="module-pywws.Plot">
<span id="detailed-api"></span><h2>Detailed API<a class="headerlink" href="#module-pywws.Plot" title="Permalink to this headline">¶</a></h2>
<p>Plot graphs of weather data according to an XML recipe.</p>
<p>usage: python Plot.py [options] data_dir temp_dir xml_file output_file
options are:</p>
<blockquote>
-h or &#8211;help            display this help</blockquote>
<p>data_dir is the root directory of the weather data
temp_dir is a workspace for temporary files e.g. /tmp
xml_file is the name of the source file that describes the plot
output_file is the name of the image file to be created e.g. 24hrs.png</p>
<p class="rubric">Functions</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.Plot.main" title="pywws.Plot.main"><tt class="xref py py-obj docutils literal"><span class="pre">main</span></tt></a>([argv])</td>
<td></td>
</tr>
</tbody>
</table>
<p class="rubric">Classes</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.Plot.BasePlotter" title="pywws.Plot.BasePlotter"><tt class="xref py py-obj docutils literal"><span class="pre">BasePlotter</span></tt></a>(params,&nbsp;raw_data,&nbsp;hourly_data,&nbsp;...)</td>
<td></td>
</tr>
<tr><td><a class="reference internal" href="#pywws.Plot.GraphPlotter" title="pywws.Plot.GraphPlotter"><tt class="xref py py-obj docutils literal"><span class="pre">GraphPlotter</span></tt></a>(params,&nbsp;raw_data,&nbsp;hourly_data,&nbsp;...)</td>
<td></td>
</tr>
</tbody>
</table>
<dl class="class">
<dt id="pywws.Plot.BasePlotter">
<em class="property">class </em><tt class="descclassname">pywws.Plot.</tt><tt class="descname">BasePlotter</tt><big>(</big><em>params</em>, <em>raw_data</em>, <em>hourly_data</em>, <em>daily_data</em>, <em>monthly_data</em>, <em>work_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#BasePlotter"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.BasePlotter" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="pywws.Plot.BasePlotter.DoPlot">
<tt class="descname">DoPlot</tt><big>(</big><em>input_file</em>, <em>output_file</em><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#BasePlotter.DoPlot"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.BasePlotter.DoPlot" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.Plot.BasePlotter.GetChildren">
<tt class="descname">GetChildren</tt><big>(</big><em>node</em>, <em>name</em><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#BasePlotter.GetChildren"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.BasePlotter.GetChildren" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.Plot.BasePlotter.GetValue">
<tt class="descname">GetValue</tt><big>(</big><em>node</em>, <em>name</em>, <em>default</em><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#BasePlotter.GetValue"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.BasePlotter.GetValue" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="class">
<dt id="pywws.Plot.Record">
<em class="property">class </em><tt class="descclassname">pywws.Plot.</tt><tt class="descname">Record</tt><a class="reference internal" href="../_modules/pywws/Plot.html#Record"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.Record" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="class">
<dt id="pywws.Plot.GraphPlotter">
<em class="property">class </em><tt class="descclassname">pywws.Plot.</tt><tt class="descname">GraphPlotter</tt><big>(</big><em>params</em>, <em>raw_data</em>, <em>hourly_data</em>, <em>daily_data</em>, <em>monthly_data</em>, <em>work_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#GraphPlotter"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.GraphPlotter" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="pywws.Plot.GraphPlotter.GetPlotList">
<tt class="descname">GetPlotList</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#GraphPlotter.GetPlotList"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.GraphPlotter.GetPlotList" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.Plot.GraphPlotter.GetDefaultRows">
<tt class="descname">GetDefaultRows</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#GraphPlotter.GetDefaultRows"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.GraphPlotter.GetDefaultRows" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.Plot.GraphPlotter.GetDefaultPlotSize">
<tt class="descname">GetDefaultPlotSize</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#GraphPlotter.GetDefaultPlotSize"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.GraphPlotter.GetDefaultPlotSize" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.Plot.GraphPlotter.GetPreamble">
<tt class="descname">GetPreamble</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#GraphPlotter.GetPreamble"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.GraphPlotter.GetPreamble" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.Plot.GraphPlotter.PlotData">
<tt class="descname">PlotData</tt><big>(</big><em>plot_no</em>, <em>plot</em>, <em>source</em><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#GraphPlotter.PlotData"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.GraphPlotter.PlotData" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="function">
<dt id="pywws.Plot.main">
<tt class="descclassname">pywws.Plot.</tt><tt class="descname">main</tt><big>(</big><em>argv=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/Plot.html#main"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Plot.main" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">pywws.Plot</a><ul>
<li><a class="reference internal" href="#introduction">Introduction</a><ul>
<li><a class="reference internal" href="#xml-graph-file-syntax">XML graph file syntax</a></li>
<li><a class="reference internal" href="#graph">graph</a></li>
<li><a class="reference internal" href="#plot">plot</a></li>
<li><a class="reference internal" href="#start">start</a></li>
<li><a class="reference internal" href="#stop">stop</a></li>
<li><a class="reference internal" href="#duration">duration</a></li>
<li><a class="reference internal" href="#layout">layout</a></li>
<li><a class="reference internal" href="#size">size</a></li>
<li><a class="reference internal" href="#fileformat">fileformat</a></li>
<li><a class="reference internal" href="#terminal">terminal</a></li>
<li><a class="reference internal" href="#lmargin">lmargin</a></li>
<li><a class="reference internal" href="#rmargin">rmargin</a></li>
<li><a class="reference internal" href="#xformat">xformat</a></li>
<li><a class="reference internal" href="#xlabel">xlabel</a></li>
<li><a class="reference internal" href="#dateformat">dateformat</a></li>
<li><a class="reference internal" href="#xtics">xtics</a></li>
<li><a class="reference internal" href="#title">title</a></li>
<li><a class="reference internal" href="#subplot">subplot</a></li>
<li><a class="reference internal" href="#bmargin">bmargin</a></li>
<li><a class="reference internal" href="#yrange">yrange</a></li>
<li><a class="reference internal" href="#y2range">y2range</a></li>
<li><a class="reference internal" href="#ytics">ytics</a></li>
<li><a class="reference internal" href="#y2tics">y2tics</a></li>
<li><a class="reference internal" href="#ylabel">ylabel</a></li>
<li><a class="reference internal" href="#ylabelangle">ylabelangle</a></li>
<li><a class="reference internal" href="#y2label">y2label</a></li>
<li><a class="reference internal" href="#y2labelangle">y2labelangle</a></li>
<li><a class="reference internal" href="#grid">grid</a></li>
<li><a class="reference internal" href="#source">source</a></li>
<li><a class="reference internal" href="#boxwidth">boxwidth</a></li>
<li><a class="reference internal" href="#id1">title</a></li>
<li><a class="reference internal" href="#command">command</a></li>
<li><a class="reference internal" href="#xcalc">xcalc</a></li>
<li><a class="reference internal" href="#ycalc">ycalc</a></li>
<li><a class="reference internal" href="#axes">axes</a></li>
<li><a class="reference internal" href="#style">style</a></li>
<li><a class="reference internal" href="#colour">colour</a></li>
<li><a class="reference internal" href="#id2">title</a></li>
</ul>
</li>
<li><a class="reference internal" href="#module-pywws.Plot">Detailed API</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="pywws.calib.html"
                        title="previous chapter">pywws.calib</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="pywws.WindRose.html"
                        title="next chapter">pywws.WindRose</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.WindRose.html" title="pywws.WindRose"
             >next</a> |</li>
        <li class="right" >
          <a href="pywws.calib.html" title="pywws.calib"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>